
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>


#define BYTEn(x, n) (*((char*)&(x)+n))
#define BYTE1(x) BYTEn(x, 1) // byte 1 (counting from 0)

#undef LOBYTE
#undef HIBYTE
#define LOBYTE(x) (*((char*)&(x))) // low byte
#define HIBYTE(x) (*((char*)&(x)+1))

int main(int argc, char* argv[])
{
    if (argc < 2)
        return 1;

    int sounds_found = 0;

    printf("File: %s\n", argv[1]);

    const int blocksize = 0x4000u;

    LPVOID lpMem = malloc(blocksize);
    if (!lpMem)
        return 2;
    int v193[4];

    unsigned int v14;
    signed int v4 = (signed int)lpMem;

    HANDLE hFile = CreateFile(argv[1], GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, /* FILE_FLAG_SEQUENTIAL_SCAN */ 0, NULL);
    if (hFile == INVALID_HANDLE_VALUE)
        return 3;

#if 0
    unsigned int v466 = GetFileSize(hFile, NULL);
    printf("Size: %u\n", v466);
#endif

    unsigned int v467;

    LONG lDistanceToMove = 0;
    LONG DistanceToMoveHigh = 0;
    DWORD NumberOfBytesRead = 0;
    DWORD v179 = 0;
    DWORD v473;
    int v474;
    int v476;

    DWORD Buffer;

    int v87;
    char v88;
    int v178;

    while (1)
    {
RESTART_LOOP:
        DistanceToMoveHigh = 0;

        v473 = SetFilePointer(hFile, 0, &DistanceToMoveHigh, FILE_CURRENT);

        ReadFile(hFile, lpMem, blocksize, &NumberOfBytesRead, NULL);
        v179 = NumberOfBytesRead;
        if (!NumberOfBytesRead)
            goto ENDADDRESS;

        v4 = (signed int)lpMem;
        v14 = 0;
        v476 = 0;
        v467 = 0;

        while ( 1 )
        {
            v474 = v14 + v4;
            Buffer = *(int *)(v14 + v4);
            if ( Buffer )
                break;

BACK_IN_THE_LOOP:
            ++v14;
            v467 = v14;

            if ( v14 > v179 - 4 )
                goto RESTART_LOOP;
        }

        break;

RESUME_LOOP:
        if ( !v476 )
        {
            v4 = (signed int)lpMem;
            v14 = v467;
            goto BACK_IN_THE_LOOP;
        }
    }

    if ( !(short)Buffer
        || BYTE1(Buffer) & 0xF9
        || (Buffer & 0xF) > 0xC
        || (Buffer & 0xF0) > 0x40
        || (lDistanceToMove = v14 + v473, v14 + v473 < 0x10)
        || Buffer == *(int *)(v14 + v4 + 4)
        || Buffer == *(int *)(v14 + v4 + 8)
        || Buffer == *(int *)(v14 + v4 + 12)
        || ((v4 = v474,
            v87 = *(int *)(v474 - 16) & 0xFFFFFDFF,
            v88 = (*(int *)(v474 - 16) & 0xFFFFFDFF) == 0,
            v178 = *(int *)(v474 - 16) & 0xFFFFFDFF,
            !v88)
        && v87 != 12) // parentheses
        || *(int *)(v474 - 12) | *(int *)(v474 - 8) | *(int *)(v474 - 4) )
        goto RESUME_LOOP;

    DistanceToMoveHigh = 0;
    if ( SetFilePointer(hFile, lDistanceToMove, &DistanceToMoveHigh, FILE_BEGIN) == -1 )
        goto ENDADDRESS;

    int v89 = -1;
    v474 = 0;
    DWORD v177 = Buffer & 0x200;

    unsigned int v92;

    while ( 2 )
    {
        while ( 2 )
        {
            ReadFile(hFile, v193, 0x10u, &NumberOfBytesRead, NULL);
            v4 = v193[0];
            int v90 = v193[3] | v193[2] | v193[1] | v193[0];

            if ( NumberOfBytesRead != 16 )
            {
                if ( (unsigned int)v474 <= 0x100 )
                    goto ENDADDRESS;
                goto SOUND_FOUND;
            }
            ++v474;
            if ( BYTE1(v4) & 0xF8
                || ((v193[0] & 0x200) != v177 && (unsigned __int16)(v193[0] & 0xFF00) != 1792) // parentheses
                || (v193[0] & 0xFu) > 0xC
                || (v193[0] & 0xF0u) > 0x40 )
            {
                if ( v90 )
                    goto RESUME_LOOP;
            }
            else
            {
                if ( v90 )
                {
                    if ( !(BYTE1(v4) & 1) )
                    {
                        if ( v89 == -1 )
                        {
                            if ( !(v193[3] | v193[2] | v193[1]) )
                            {
                                if ( v178 == v193[0] )
                                {
                                    if ( v474 == 64 || v474 == 128 || v474 == 256 || v474 == 512 || v474 == 1024 )
                                        v89 = 16 * v474;
                                }
                            }
                        }
                        continue;
                    }
                    if ( (unsigned int)v474 < 0x20 )
                        goto RESUME_LOOP;
                    if ( v89 != -1 )
                    {
                        if ( v474 >= v89 >> 2 )
                        {
                            SetFilePointer(hFile, v89 - 16, 0, FILE_CURRENT);
                            ReadFile(hFile, v193, 4u, &NumberOfBytesRead, NULL);
                            SetFilePointer(hFile, 12 - v89, 0, FILE_CURRENT);
                            if ( BYTE1(v193[0]) & 1 )
                                goto LABEL_439;
                        }
                    }
SOUND_FOUND:
                    ++sounds_found;
                    printf("%lu\n", lDistanceToMove - 16);
                    v476 = 1;
                    goto RESUME_LOOP;
                }
            }
            break;
        }
        if ( v89 == -1 )
        {
            if ( v474 != 64 && v474 != 128 && v474 != 256 && v474 != 512 && v474 != 1024 )
                goto LABEL_446;
            v89 = 16 * v474;

            continue;
        }
        break;
    }

    if ( v474 < v89 )
    {
LABEL_446:
        if ( (unsigned int)v474 <= 0x200 )
            goto RESUME_LOOP;
        SetFilePointer(hFile, -16, 0, FILE_CURRENT);
        goto SOUND_FOUND;
    }
LABEL_439:
    if ( v89 <= 0x400 )
        v92 = v89 >> 4;
    else
        LOBYTE(v92) = (v89 >> 11) | 0x80;

    ++sounds_found;
    printf("weird: %lu (%i) (%i)\n", lDistanceToMove - 16, v92, -1448301651);
    v476 = 1;
    goto RESUME_LOOP;

ENDADDRESS:
    if (hFile)
    {
        CloseHandle(hFile);
        hFile = NULL;
    }
    if (lpMem)
    {
        free(lpMem);
        lpMem = NULL;
    }

    printf("Sounds found: %i\n", sounds_found);

    return 0;
}
